//
//  MyViewMain.m
//  My2048
//
//  Created by Ibokan on 15/10/19.
//  Copyright © 2015年 Crazy凡. All rights reserved.
//

#import "MyViewMain.h"
#import "MyView.h"
#define margin 5//定义方块间的距离
#define Num 4 //定义N阶
@interface MyViewMain ()
@property (nonatomic,strong)NSArray * top;
@property (nonatomic,strong)NSArray * right;
@property (nonatomic,strong)NSArray * left;
@property (nonatomic,strong)NSArray * buttom;
@property (nonatomic,strong)NSMutableArray *array;
@property (nonatomic,assign)BOOL flag;
@end

@implementation MyViewMain

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self otherInitWith:frame];
        self.count = 0;
    }
    return self;
}
- (void)otherInitWith:(CGRect)frame
{
    _flag = NO;
    int w = frame.size.width;
    int h = frame.size.height;
    w = w < h ? w : h;
    //数量+1；
    w -= (Num + 1) * margin;
    w /= Num;
    h = w;
    
    NSMutableArray *temp = [NSMutableArray array];
    for (int i = 0 ; i < Num * Num ; i++) {
        MyView * a = [MyView myviewWithframe:CGRectMake((i%Num)*(w+margin)+margin, (i/Num)*(w + margin)+margin, w, w)];
        UIView * p = [[UIView alloc]initWithFrame:a.frame];
        p.backgroundColor = [UIColor colorWithRed:227.0/255.0 green:106.0/255.0 blue:0 alpha:1];
        [self addSubview:p];
        [a setValue:0];
        [self addSubview:a];
        [temp addObject:a];
    }
    NSMutableArray *top = [NSMutableArray array];
    NSMutableArray *left = [NSMutableArray array];
    NSMutableArray *right = [NSMutableArray array];
    NSMutableArray *buttom = [NSMutableArray array];
    for (int i = 0 ; i < Num * Num ; i++) {
        MyView *p = temp[i];
        i / Num == 0 ? ([top addObject:p] , p.top = p) : nil;
        i % Num == 0 ? ([left addObject:p] , p.left = p) : nil;
        ( i + 1 ) % Num == 0 ? ([right addObject:p] , p.right = p) : nil;
        i / Num == (Num - 1) ? ([buttom addObject:p] , p.buttom = p) : nil;
        
        p.top = p.top ? nil : temp[i - Num];
        p.left = p.left ? nil : temp[i - 1];
        p.right = p.right ? nil : temp[i + 1];
        p.buttom = p.buttom ? nil : temp[i + Num];
        
    }
    self.top = [NSArray arrayWithArray:top];
    self.left = [NSArray arrayWithArray:left];
    self.right = [NSArray arrayWithArray:right];
    self.buttom = [NSArray arrayWithArray:buttom];
    
    _array = [NSMutableArray arrayWithArray:temp];
    [self addNewNum];
}
- (void)moveWith:(int)a
{
    _flag = NO;//是否发生移动的标记位
    NSArray *ap = a==0 ? self.top : a==1? self.left :a==2 ? self.buttom :self.right;//获取数组
    for (MyView *p in ap) { [self ConfigMove:p with:a]; } //实现move
    
    _flag ? [self performSelector:@selector(addNewNum) withObject:nil afterDelay:0.2] : nil; //判断是否调用加数方法；
}
- (void)ConfigMove:(MyView*)b with:(int)n;
{
    MyView *a = b; //让a指向b
    while (1) {
        b = [self getNext:b N:n];//b 变成 b的下一个
        if (b.flag) //如果b 不为空
        {
            if (a.flag) //如果a 不为空
            {
                if (a.value == b.value) { //如果ab值相同，则合并，且a指向下一个
                    [a setValue:(2*b.value)];
                    self.count += 2*b.value;
                    [b setValue:0];
                    [_array addObject:b];
                    a = [self getNext:a N:n];
                    _flag = YES;
                }
                else//值不同，则判断b是不是a的下一个
                {
                    MyView *temp = [self getNext:a N:n];
                    if (temp == b) { //是下一个则让a指向b；
                        a = temp;
                    }
                    else//不是则让b移动到a的下一个
                    {
                        a = temp;
                        [a setValue:b.value];
                        [b setValue:0];
                        [_array removeObject:a];
                        [_array addObject:b];
                        _flag = YES;
                    }
                }
            }
            else//a为空则直接把b移动到a，然后a指向下一个；
            {
                [a setValue:b.value];
                [b setValue:0];
                [_array removeObject:a];
                [_array addObject:b];
                _flag = YES;
            }
        }
        if([self getNext:b N:n] == nil) {return;}//下一个是nil则返回
    }
}
- (MyView *)getNext:(MyView *)view N:(int)n
{
    return n == 0 ? view.buttom : n == 1 ? view.right : n == 2 ? view.top : view.left;
}
- (void)addNewNum
{
    MyView * p = _array[arc4random() % _array.count];
    [p setValue:((int)[[NSDate date]timeIntervalSince1970]%2 ? 2 : 4)];
    [_array removeObject:p];
    if (_array.count == 0 && [self isEndOfTheGame]) {
        NSLog(@"游戏结束！");
        return;
    }
}
- (BOOL)isEndOfTheGame
{
    for (int i = 0 ; i < _left.count; i++) {
        MyView * p = _left[i];
        while ( p.right != nil )
        {
            if ([self hasEqualValue:p]) { return NO; }
            p = p.right;
        }
        if ([self hasEqualValue:p]) { return NO; }
    }
    return YES;
}
- (BOOL)hasEqualValue:(MyView*)temp
{
    return temp.value == temp.buttom.value ? YES : temp.value == temp.left.value ? YES : NO;
}
@end
